// PciDlgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PciDlg.h"
#include "PciDlgDlg.h"
#include "winsvc.h"
#include "windows.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

UINT ServiceInfo(LPCTSTR ServiceName) {
    SC_HANDLE       schService;
    SC_HANDLE       schSCManager;
    DWORD           RC;
    SERVICE_STATUS  ssStatus;
    UINT            return_value;

    schSCManager = OpenSCManager(
                                NULL,                   // machine (NULL == local)
                                NULL,                   // database (NULL == default)
                                SC_MANAGER_ALL_ACCESS   // access required
                               );
    if (!schSCManager) return -1;
    schService = OpenService(schSCManager, ServiceName, SERVICE_ALL_ACCESS);
    if (!schService) {
        RC = GetLastError();
        CloseServiceHandle(schSCManager);
        if (RC == ERROR_SERVICE_DOES_NOT_EXIST) return -2;
                                           else return -1;
    }
    QueryServiceStatus(schService, &ssStatus);
    if(ssStatus.dwCurrentState == SERVICE_RUNNING) return_value = 1;
                                              else return_value = 0;
    CloseServiceHandle(schService);
    CloseServiceHandle(schSCManager);
    return return_value;
}

UINT StartPCIDumpService(LPCTSTR ServiceName) {
    SC_HANDLE       schService;
    SC_HANDLE       schSCManager;
    DWORD           RC;
    UINT            return_value;

    schSCManager = OpenSCManager(
                                NULL,                   // machine (NULL == local)
                                NULL,                   // database (NULL == default)
                                SC_MANAGER_ALL_ACCESS   // access required
                               );
    if (!schSCManager) return -1;
    schService = OpenService(schSCManager, ServiceName, SERVICE_ALL_ACCESS);
    if (!schService) {
        RC = GetLastError();
        CloseServiceHandle(schSCManager);
        if (RC == ERROR_SERVICE_DOES_NOT_EXIST) return -2;
                                           else return -1;
    }
    return_value = StartService(schService, 0, NULL) ? 1 : -1;
    RC = GetLastError();
    CloseServiceHandle(schService);
    CloseServiceHandle(schSCManager);
    return return_value;
}

UINT CreatePCIDumpService(LPCTSTR ServiceName) {
    SC_HANDLE       schService;
    SC_HANDLE       schSCManager;
    DWORD           RC;
    UINT            return_value;
    CHAR path_name1[MAX_PATH];
    CHAR path_name[MAX_PATH];
    CHAR cur_path_name[MAX_PATH];
    CHAR sys_path_name[MAX_PATH];
    CHAR drv_path_name[MAX_PATH];

    GetSystemDirectory(sys_path_name, MAX_PATH-40);
    GetCurrentDirectory(MAX_PATH-40, cur_path_name);
    sprintf(path_name, "%s\\drivers\\%s.sys", sys_path_name, ServiceName);
    sprintf(path_name1, "%s\\PciDumpEx.sys", cur_path_name);
    sprintf(drv_path_name, "System32\\drivers\\%s.sys", ServiceName);

    return_value = CopyFile(path_name1, path_name, 0);
    return_value = GetLastError();

    schSCManager = OpenSCManager(
                                NULL,                   // machine (NULL == local)
                                NULL,                   // database (NULL == default)
                                SC_MANAGER_ALL_ACCESS   // access required
                               );
    if (!schSCManager) return -1;
    schService = CreateService(schSCManager, ServiceName, ServiceName, SERVICE_ALL_ACCESS,
                                SERVICE_KERNEL_DRIVER, SERVICE_DEMAND_START, SERVICE_ERROR_IGNORE,
                                drv_path_name, NULL, NULL, NULL, NULL, NULL);
    if (!schService) {
        RC = GetLastError();
        CloseServiceHandle(schSCManager);
        if (RC == ERROR_SERVICE_DOES_NOT_EXIST) return -2;
                                           else return -1;
    }
    return_value = StartService(schService, 0, NULL) ? 1 : -1;
    return_value = GetLastError();
    CloseServiceHandle(schService);
    CloseServiceHandle(schSCManager);
    return return_value;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPciDlgDlg dialog

CPciDlgDlg::CPciDlgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPciDlgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPciDlgDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPciDlgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPciDlgDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPciDlgDlg, CDialog)
	//{{AFX_MSG_MAP(CPciDlgDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE, OnSelchangedTree)
	ON_EN_UPDATE(IDC_VENDOR_ID, OnUpdateVendorId)
	ON_EN_UPDATE(IDC_DEVICE_ID, OnUpdateDeviceId)
	ON_EN_UPDATE(IDC_CLASS_ID, OnUpdateClassId)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPciDlgDlg message handlers

BOOL CPciDlgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
    int s = ServiceInfo(NT_PciDump_SVC_NAME);

    if(s == 1) {
        // Ok
    } else
    if(s == 0) {
        s = StartPCIDumpService(NT_PciDump_SVC_NAME);
    } else
    if(s == -2) {
        s = CreatePCIDumpService(NT_PciDump_SVC_NAME);
//        s = StartPCIDumpService(NT_PciDump_SVC_NAME);
    }
    if(s < 0) {
        ExitProcess(s);
    }

	// TODO: Add extra initialization here
    FillDevList();
//    CTreeCtrl* pList = (CTreeCtrl*)GetDlgItem(IDC_TREE);
    
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPciDlgDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPciDlgDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPciDlgDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPciDlgDlg::OnClickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

void CPciDlgDlg::FillDevList()
{
    PCHAR BusStr[sizeof("PCI Bus ")+10];
    PCHAR DevStr[sizeof("Device ")+5];
    PCHAR FuncStr[sizeof("Function ")+5];

    ULONG BusId=0;
    ULONG DevId=0;
    ULONG DevFunc=0;

    ULONG returned;

    HICON hIcon[3];
    BOOLEAN mf;

    PciDump_GetHeader_USER_IN buf_in;
    PciDump_GetHeader_USER_OUT buf_out;

    CTreeCtrl* pList = (CTreeCtrl*)GetDlgItem(IDC_TREE);

    int n;
    m_imageList.Create(16, 16, 0, 8, 8); // 32, 32 for large icons
    hIcon[0] = AfxGetApp()->LoadIcon(IDI_BUS);
    hIcon[1] = AfxGetApp()->LoadIcon(IDI_DEVICE);
    hIcon[2] = AfxGetApp()->LoadIcon(IDI_FUNCTION);
    for (n = 0; n < 3; n++) {
    	m_imageList.Add(hIcon[n]);
    }

    static char* color[] = {"Bus", "Device", "Function"};

    HANDLE h;
    h = CreateFile(NT_PciDump_USER_NAME, GENERIC_READ | GENERIC_WRITE,
                   FILE_SHARE_READ | FILE_SHARE_WRITE,
                   NULL,
                   OPEN_EXISTING,
                   FILE_ATTRIBUTE_NORMAL/* | FILE_FLAG_NO_BUFFERING*/,  NULL);

    pList->SetImageList(&m_imageList, TVSIL_NORMAL);
    // tree structure common values
    TV_INSERTSTRUCT tvinsert;
    tvinsert.hInsertAfter = TVI_LAST;
    tvinsert.item.mask = TVIF_IMAGE | TVIF_SELECTEDIMAGE |
    					 TVIF_TEXT;
    tvinsert.item.hItem = NULL; 
    tvinsert.item.state = 0;
    tvinsert.item.stateMask = 0;
    tvinsert.item.cchTextMax = 6;
    tvinsert.item.iSelectedImage = 1;
    tvinsert.item.cChildren = 0;
    tvinsert.item.lParam = 0;
	// top l    evel
    while(h != ((HANDLE)-1)) {

        buf_in.BusNumber = BusId;
        buf_in.DeviceNumber = 0;
        buf_in.FunctionNumber = 0;
        
        if(!DeviceIoControl(h,IOCTL_PciDump_GetHeader,
                            &buf_in,sizeof(buf_in),
                            &buf_out,sizeof(buf_out),
                            &returned,NULL)
                  ||
            buf_out.status == 0) {
            CloseHandle(h);
            h = ((HANDLE)-1);
            continue;
        }
        
        sprintf((PCHAR)&BusStr, "PCI Bus %d", BusId);
        tvinsert.hParent = NULL;
        tvinsert.item.iImage = 0;
    	tvinsert.item.iSelectedImage = 0;
        tvinsert.item.pszText = (PCHAR)&BusStr;
        HTREEITEM hBusItem = pList->InsertItem(&tvinsert);
        pList->SetItemData(hBusItem, DevAddrToDword32(BusId, -1, -1));

        for(DevId=0; DevId<PCI_MAX_DEVICES; DevId++) {
            
            buf_in.BusNumber = BusId;
            buf_in.DeviceNumber = DevId;
            buf_in.FunctionNumber = 0;

            DeviceIoControl(h,IOCTL_PciDump_GetHeader,
                                &buf_in,sizeof(buf_in),
                                &buf_out,sizeof(buf_out),
                                &returned,NULL);

            if(buf_out.status == 2)
                continue;

            mf = (buf_out.pciData.HeaderType & PCI_MULTIFUNCTION) != 0;

            buf_in.BusNumber = BusId;
            buf_in.DeviceNumber = DevId;
            buf_in.FunctionNumber = 1;

            DeviceIoControl(h,IOCTL_PciDump_GetHeader,
                                &buf_in,sizeof(buf_in),
                                &buf_out,sizeof(buf_out),
                                &returned,NULL);

            mf |= (buf_out.status != 2);

            sprintf((PCHAR)&DevStr, "Device %x%s", DevId, mf ? " (M/F)" : "");
            tvinsert.hParent = hBusItem;
            tvinsert.item.iImage = 1;
            tvinsert.item.iSelectedImage = 1;
            tvinsert.item.pszText = (PCHAR)&DevStr;
            HTREEITEM hDevItem = pList->InsertItem(&tvinsert);

            if(!mf) {
                pList->SetItemData(hDevItem, DevAddrToDword32(BusId, DevId, 0));
                continue;
            } else {
                pList->SetItemData(hDevItem, DevAddrToDword32(BusId, DevId, -1));
            }

            for(DevFunc=0; DevFunc<PCI_MAX_FUNCTION; DevFunc++) {

                buf_in.BusNumber = BusId;
                buf_in.DeviceNumber = DevId;
                buf_in.FunctionNumber = DevFunc;

                DeviceIoControl(h,IOCTL_PciDump_GetHeader,
                                    &buf_in,sizeof(buf_in),
                                    &buf_out,sizeof(buf_out),
                                    &returned,NULL);

                if(buf_out.status == 2)
                    continue;
                
                sprintf((PCHAR)&FuncStr, "Function %x", DevFunc);
                tvinsert.hParent = hDevItem;
                tvinsert.item.iImage = 2;
            	tvinsert.item.iSelectedImage = 2;
                tvinsert.item.pszText = (PCHAR)&FuncStr;
                HTREEITEM hDevFuncItem = pList->InsertItem(&tvinsert);
                pList->SetItemData(hDevFuncItem, DevAddrToDword32(BusId, DevId, DevFunc));

            }
        }

        BusId++;
    }
      
    if(h != ((HANDLE)-1)) {
        CloseHandle(h);
        h = ((HANDLE)-1);
    }
}

DWORD CPciDlgDlg::DevAddrToDword32(ULONG BusId, ULONG DevId, ULONG DevFunc)
{
    ULONG DevFunc_sh = 0;
    ULONG DevId_sh = DevFunc_sh+3+1;
    ULONG BusId_sh = DevId_sh+5+1;

    ULONG DevFunc_m = (1 << DevId_sh)-1;
    ULONG DevId_m = ((1 << BusId_sh)-1) & ~DevFunc_m;

    DWORD DevFunc_bits = (DevFunc << DevFunc_sh) & DevFunc_m;
    DWORD DevId_bits = (DevId << DevId_sh) & DevId_m;
    DWORD BusId_bits = BusId << BusId_sh;

    return BusId_bits | DevId_bits | DevFunc_bits;
}

void CPciDlgDlg::Dword32ToDevAddr(DWORD param, ULONG *pBusId, ULONG *pDevId, ULONG *pDevFunc)
{
    ULONG DevFunc_sh = 0;
    ULONG DevId_sh = DevFunc_sh+3+1;
    ULONG BusId_sh = DevId_sh+5+1;

    ULONG DevFunc_m = (1 << DevId_sh)-1;
    ULONG DevId_m = ((1 << BusId_sh)-1) & ~DevFunc_m;
    ULONG BusId_m = (-1) & ~(DevFunc_m | DevId_m);

    if((param & DevFunc_m) == DevFunc_m) {
        *pDevFunc = -1;
    } else {
        *pDevFunc = (param & DevFunc_m) >> DevFunc_sh;
    }
    if((param & DevId_m) == DevId_m) {
        *pDevId = -1;
    } else {
        *pDevId = (param & DevId_m) >> DevId_sh;
    }
    if((param & BusId_m) == BusId_m) {
        *pBusId = -1;
    } else {
        *pBusId = (param & BusId_m) >> BusId_sh;
    }
}

void CPciDlgDlg::OnSelchangedTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
    HTREEITEM hSelected = pNMTreeView->itemNew.hItem;
    ULONG returned;
    ULONG tmp;

    if (hSelected != NULL) {
        ULONG BusId;
        ULONG DevId;
        ULONG DevFunc;
        PciDump_GetHeader_USER_IN buf_in;
        HANDLE h;

        PciDump_GetHeader_USER_OUT buf;
    
        CTreeCtrl* pList = (CTreeCtrl*)GetDlgItem(IDC_TREE);
        CButton* pBt;

        Dword32ToDevAddr(pList->GetItemData(hSelected), &BusId, &DevId, &DevFunc);

        if(DevFunc == -1) {
            h = (void*)(-1);
            goto skip_doc_update;
        }

        h = CreateFile(NT_PciDump_USER_NAME, GENERIC_READ | GENERIC_WRITE,
                       FILE_SHARE_READ | FILE_SHARE_WRITE,
                       NULL,
                       OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL/* | FILE_FLAG_NO_BUFFERING*/,  NULL);
        if(h != ((HANDLE)-1)) {

            buf_in.BusNumber = BusId;
            buf_in.DeviceNumber = DevId;
            buf_in.FunctionNumber = DevFunc;

            DeviceIoControl(h,IOCTL_PciDump_GetHeader,
                                &buf_in,sizeof(buf_in),
                                &buf,sizeof(buf),
                                &returned,NULL);
            CloseHandle(h);
        }

skip_doc_update:;

#define PCITXT(t)     ( (h != ((HANDLE)-1)) ? (t) : "")

            memcpy(&CurDevInfo, &(buf.pciData), sizeof(CurDevInfo));
            // Vendor ID
            sprintf(dev_str, "%04x", CurDevInfo.VendorID);
            SetDlgItemText(IDC_VENDOR_ID, PCITXT(dev_str));
            // Device ID
            sprintf(dev_str, "%04x", CurDevInfo.DeviceID);
            SetDlgItemText(IDC_DEVICE_ID, PCITXT(dev_str));

            sprintf(dev_str, "%02x", CurDevInfo.RevisionID);
            SetDlgItemText(IDC_REV_ID, PCITXT(dev_str));

            sprintf(dev_str, "%02x", CurDevInfo.BaseClass);
            SetDlgItemText(IDC_CLASS_ID, PCITXT(dev_str));
        
            sprintf(dev_str, "%02x", CurDevInfo.SubClass);
            SetDlgItemText(IDC_SUBCLASS_ID, PCITXT(dev_str));
            // Registers (CMD)
            sprintf(dev_str, "%04x", CurDevInfo.Command);
            SetDlgItemText(IDC_CMDREG_ID, PCITXT(dev_str));

#define PCI_SET_CMD_CHECK(elm, id, flg) \
            pBt = (CButton*)GetDlgItem(id); \
            pBt->SetCheck((CurDevInfo.##elm & flg) ? (h != ((HANDLE)-1)) : 0);

            PCI_SET_CMD_CHECK(Command, IDC_CHECK_IOSPACE, PCI_ENABLE_IO_SPACE);
            PCI_SET_CMD_CHECK(Command, IDC_CHECK_MEMSPACE, PCI_ENABLE_MEMORY_SPACE);
            PCI_SET_CMD_CHECK(Command, IDC_CHECK_BM, PCI_ENABLE_BUS_MASTER);
            PCI_SET_CMD_CHECK(Command, IDC_CHECK_SPEC_CYCLE, PCI_ENABLE_SPECIAL_CYCLES);
            PCI_SET_CMD_CHECK(Command, IDC_CHECK_WRITE_INV, PCI_ENABLE_WRITE_AND_INVALIDATE);
            PCI_SET_CMD_CHECK(Command, IDC_CHECK_VGA_COMP, PCI_ENABLE_VGA_COMPATIBLE_PALETTE);
            PCI_SET_CMD_CHECK(Command, IDC_CHECK_WT_CYCLE, PCI_ENABLE_WAIT_CYCLE);
            PCI_SET_CMD_CHECK(Command, IDC_CHECK_SERR, PCI_ENABLE_SERR);
            PCI_SET_CMD_CHECK(Command, IDC_CHECK_FAST_B2B, PCI_ENABLE_FAST_BACK_TO_BACK);

            // Registers (Status)
            sprintf(dev_str, "%04x", CurDevInfo.Status);
            SetDlgItemText(IDC_STATUSREG_ID, PCITXT(dev_str));

            PCI_SET_CMD_CHECK(Status, IDC_CHECK_FAST_B2B_2, PCI_STATUS_FAST_BACK_TO_BACK);
            PCI_SET_CMD_CHECK(Status, IDC_CHECK_DATA_PARITY, PCI_STATUS_DATA_PARITY_DETECTED);
            PCI_SET_CMD_CHECK(Status, IDC_CHECK_FAST_B2B, PCI_STATUS_DEVSEL);

            // Registers (Header type)
            sprintf(dev_str, "%02x", CurDevInfo.HeaderType);
            SetDlgItemText(IDC_HDRTYPE_ID, PCITXT(dev_str));

            PCI_SET_CMD_CHECK(HeaderType, IDC_CHECK_MULTIFUNC, PCI_MULTIFUNCTION);
            PCI_SET_CMD_CHECK(HeaderType, IDC_CHECK_BRIDGE, PCI_BRIDGE_TYPE);

            // Registers (others)
            sprintf(dev_str, "%02x", CurDevInfo.ProgIf);
            SetDlgItemText(IDC_PROGREG_ID, PCITXT(dev_str));

            sprintf(dev_str, "%02x", CurDevInfo.CacheLineSize);
            SetDlgItemText(IDC_CACHE_LINE, PCITXT(dev_str));

            sprintf(dev_str, "%02x", CurDevInfo.BIST);
            SetDlgItemText(IDC_BIST_ID, PCITXT(dev_str));

            sprintf(dev_str, "%02x", CurDevInfo.LatencyTimer);
            SetDlgItemText(IDC_LATENCY_ID, PCITXT(dev_str));

            if((CurDevInfo.HeaderType & ~PCI_MULTIFUNCTION) == PCI_DEVICE_TYPE ||
                (h == ((HANDLE)-1)) ) {

                sprintf(dev_str, "%02x", CurDevInfo.u.type0.InterruptLine);
                SetDlgItemText(IDC_INTLN_ID, PCITXT(dev_str));

                sprintf(dev_str, "%02x", CurDevInfo.u.type0.InterruptPin);
                SetDlgItemText(IDC_INTPIN_ID, PCITXT(dev_str));

                sprintf(dev_str, "%02x", CurDevInfo.u.type0.MinimumGrant);
                SetDlgItemText(IDC_MINGRANT_ID, PCITXT(dev_str));

                sprintf(dev_str, "%02x", CurDevInfo.u.type0.MaximumLatency);
                SetDlgItemText(IDC_MAXLAT_ID, PCITXT(dev_str));

#define FILL_BASEADDR_ITEMS(i) \
                sprintf(dev_str, "%08x", CurDevInfo.u.type0.BaseAddresses[i] & 0xfffffffe); \
                SetDlgItemText(IDC_BASEADDR##i##_ID, PCITXT(dev_str)); \
                SetDlgItemText(IDC_BASEADDRTYPE##i##_ID, \
                    (CurDevInfo.u.type0.BaseAddresses[i] & PCI_ADDRESS_IO_SPACE) ? PCITXT("IO") : PCITXT("Mem")); \
                tmp = CurDevInfo.u.type0.BaseAddresses[i] & PCI_ADDRESS_MEMORY_TYPE_MASK; \
                SetDlgItemText(IDC_BASEADDRMT##i, \
                (tmp) ? (tmp == 2 ? PCITXT("20 bit") : PCITXT("64 bit")) : PCITXT("32 bit")); \
                pBt = (CButton*)GetDlgItem(IDC_BASEADDR_CHK_PF##i); \
                pBt->SetCheck((CurDevInfo.u.type0.BaseAddresses[i] & PCI_ADDRESS_MEMORY_PREFETCHABLE) ? (h != ((HANDLE)-1)) : 0);

                FILL_BASEADDR_ITEMS(0)
                FILL_BASEADDR_ITEMS(1)
                FILL_BASEADDR_ITEMS(2)
                FILL_BASEADDR_ITEMS(3)
                FILL_BASEADDR_ITEMS(4)
                FILL_BASEADDR_ITEMS(5)

                sprintf(dev_str, "%08x", CurDevInfo.u.type0.ROMBaseAddress & 0xfffffffe); \
                SetDlgItemText(IDC_ROMBASEADDR_ID, PCITXT(dev_str)); \

                PCI_SET_CMD_CHECK(u.type0.ROMBaseAddress, IDC_ROMBASE_CHK, PCI_ROMADDRESS_ENABLED);

            } else {
                SetDlgItemText(IDC_INTLN_ID, "");
                SetDlgItemText(IDC_INTPIN_ID, "");
            }
            // Registers (others)

        }
	
	*pResult = 0;
}

typedef struct _str2id {
    ULONG id;
    CCHAR* str;
} str2id;

void CPciDlgDlg::OnUpdateVendorId() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_UPDATE flag ORed into the lParam mask.

    const str2id v_names[] = {
        {0x0000, "Gammagraphx, Inc."},
        {0x0033, "Paradyne Corp."},
        {0x003D, "Lockheed Martin Corp."},
        {0x0070, "Hauppauge Computer Works Inc."},
        {0x0675, "Dynalink"},
        {0x0700, "Lava Computer MFG Inc."},
        {0x0815, "LinTech GmbH"},
        {0x0871, "Berkom"},
        {0x0914, "Shanghai Dare Technologies Ltd."},
        {0x09C1, "Arris"},
        {0x0A89, "BREA Technologies Inc."},
        {0x0E11, "Compaq Computer Corp."},
        {0x1000, "LSI Logic"},
        {0x1002, "ATI Technologies"},
        {0x1003, "ULSI"},
        {0x1004, "VLSI Technology"},
/*        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},
        {0x1002, "ATI"},*/
        {0x1022, "AMD"},
        {0x102B, "Matrox"},
        {0x1039, "SiS"},
        {0x103C, "Hewlett-Packard Company"},
        {0x105a, "Promise"},
        {0x1065, "Texas Microsystems"},
        {0x1078, "Cyrix"},
        {0x1080, "Cypress"},
        {0x1095, "CMD"},
        {0x10b9, "Acer Labs"},
        {0x10de, "nVIDIA"},
        {0x10ec, "ATI"},
        {0x1103, "High Point"},
        {0x1106, "VIA"},
        {0x1166, "Server Works"},
        {0x16ca, "Cenatek"},
        {0x8086, "Intel"},
        {0xffff, 0},
    };
	
	// TODO: Add your control notification handler code here
    SetDlgItemText(IDC_VENDOR__TXT_ID, "");
    for(int i=0; v_names[i].str; i++) {
        if(v_names[i].id == CurDevInfo.VendorID) {
            SetDlgItemText(IDC_VENDOR__TXT_ID, v_names[i].str);
        }
    }

}

void CPciDlgDlg::OnUpdateDeviceId() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_UPDATE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
    const str2id v_names[] = {
        {0x808624cb, "ICH4 ATA 100"},
        {0x10b95229, "Aladdin ATA/ATA33 controller"},
        {0x10de01bc, "nForce ATA"},
        {0x10227441, "AMD 768 ATA"},
        {0x11060571, "ATAxxx controller"},
        {0x10395513, "5591 ATA33"},
        {0x10950649, "CMD 649 ATA 100"},
        {0x1080c693, "82C693 ATA"},
        {0x10780102, "5530 ATA33"},
        {0x11660211, "ROSB4 ATA33"},
        {0x105a4d68, "TX2 ATA100"},
        {0x11030004, "HPT366/368/370/372 ATA"},
        {0x16ca0001, "Rocket Drive"},
        {0x10025046, "Rage 128 Pro"},
        {0xffff, 0},
    };
    ULONG z = (CurDevInfo.VendorID << 16) | CurDevInfo.DeviceID;
	
	// TODO: Add your control notification handler code here
    SetDlgItemText(IDC_DEVICE_TXT_ID, "");
    for(int i=0; v_names[i].str; i++) {
        if(v_names[i].id == z) {
            SetDlgItemText(IDC_DEVICE_TXT_ID, v_names[i].str);
        }
    }
	
}

void CPciDlgDlg::OnUpdateClassId() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_UPDATE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
    const str2id v_names[] = {
        {0x01, "Mass Storage"},
        {0x02, "Network Card"},
        {0x03, "Video Adapter"},
        {0x04, "Multimedia Device"},
        {0x05, "Memory"},
        {0x06, "Bridge Device"},
        {0x07, "Simple Communication Device"},
        {0x08, "Base Peripheral"},
        {0x09, "Input Device"},
        {0x0a, "Docking Device"},
        {0x0b, "Processor"},
        {0x0c, "Serial Bus"},
        {0xffff, 0},
    };
	
	// TODO: Add your control notification handler code here
    SetDlgItemText(IDC_CLASS_TXT_ID, "");
    for(int i=0; v_names[i].str; i++) {
        if(v_names[i].id == CurDevInfo.BaseClass) {
            SetDlgItemText(IDC_CLASS_TXT_ID, v_names[i].str);
        }
    }
	
}
